<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk Guestbook
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2009-2012 The PHP Group
* @version    3.0 build:20120924
*/

session_start();
require_once 'qtg_init.php';
if ( !isset($_SESSION['qtgAuth']) || $_SESSION['qtgAuth']!='yes' ) HtmlRedirect('qtg_adm_login.php'); // CHECK LOGIN

include GetLang().'qtg_adm.php';
include GetLang().'qtg_map.php';
include GetLang().'qtg_map_adm.php';

// INITIALISE

if ( !isset($qtg_gkey) ) $qtg_gkey='';
if ( !isset($qtg_gcenter) ) $qtg_gcenter='50.8468142558,4.35238838196';
if ( !isset($qtg_gzoom) ) $qtg_gzoom='6';
if ( !isset($qtg_gbuttons) ) $qtg_gbuttons='P11000';
if ( !isset($qtg_gfind) ) $qtg_gfind='Brussels, Belgium';
if ( !isset($qtg_gsymbol) ) $qtg_gsymbol=false;

$qtg_skin='bin/css';   //override the skin in this page
$pg_name=$L['Map'];
$pg_url='qtg_adm_map.php';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // CHECK values
  $qtg_gkey = trim($_POST['qtg_gkey']); if ( strlen($qtg_gkey)<8 ) $qtg_gkey='';
  if ( isset($_POST['qtg_gcenter']) ) { $qtg_gcenter = trim($_POST['qtg_gcenter']); } else { $qtg_gcenter = '50.8468142558,4.35238838196'; }
  if ( isset($_POST['qtg_gzoom']) ) { $qtg_gzoom = trim($_POST['qtg_gzoom']); } else { $qtg_gzoom = '5'; }
  if ( !isset($_POST['maptype']) ) $_POST['maptype']='P';
  if ( !isset($_POST['qtg_gsymbol']) ) $_POST['qtg_gsymbol']=false;
  $qtg_gbuttons = substr($_POST['maptype'],0,1).(isset($_POST['streetview']) ? '1' : '0').(isset($_POST['map']) ? '1' : '0').(isset($_POST['scale']) ? '1' : '0').(isset($_POST['overview']) ? '1' : '0').(isset($_POST['mousewheel']) ? '1' : '0');
  if ( isset($_POST['qtg_gfind']) ) { $qtg_gfind = trim($_POST['qtg_gfind']); } else { $qtg_gfind='Brussels, Belgium'; }
  if ( empty($_POST['qtg_gsymbol']) ) { $qtg_gsymbol=false; } else { $qtg_gsymbol=$_POST['qtg_gsymbol']; }

  // SAVE values
  if ( empty($error) )
  {
    $strTxt = '<?php
    $qtg_gkey = "'.$qtg_gkey.'";
    $qtg_gcenter = "'.$qtg_gcenter.'";
    $qtg_gzoom = "'.$qtg_gzoom.'";
    $qtg_gbuttons = "'.$qtg_gbuttons.'";
    $qtg_gfind = "'.$qtg_gfind.'";
    $qtg_gsymbol = '.($qtg_gsymbol ? '"'.$qtg_gsymbol.'"' : 'false').';
    $qtg_gshadow = '.(file_exists('map/'.$qtg_gsymbol.'_shadow.png') ? 'true' : 'false').';
    $qtg_gprinticon = '.(file_exists('map/'.$qtg_gsymbol.'.gif') ? 'true' : 'false').';
    $qtg_gprintshadow = '.(file_exists('map/'.$qtg_gsymbol.'_shadow.gif') ? 'true' : 'false').';';

    if (!is_writable('config/config_map.php')) $error='Impossible to write into the file [config/config_map.php].';

    if ( empty($error) )
    {
       if (!$handle = fopen('config/config_map.php', 'w')) $error='Impossible to open the file [config/config_map.php].';
    }
    if ( empty($error) )
    {
       if (fwrite($handle, $strTxt) === FALSE)
       {
         $error = 'Impossible to write into the file [config/config_map.php].';
       }
       else
       {
         fclose($handle);
       }
    }
  }
  // exit
  $_SESSION['pagedialog'] = (empty($error) ? 'O|'.$L['S_save'] : 'E|'.$error);

}

if ( !empty($qtg_gkey) ) include 'qtg_map_lib.php';

// --------
// HTML START
// --------

$oHtml->scripts[] = '<script type="text/javascript">
<!--
var enterkeyPressed=false;
function ValidateForm(theForm,enterkeyPressed)
{
  if (enterkeyPressed) return false;
}
function radioHighlight(id)
{
  var doc = document;
  var radios = doc.getElementsByClassName("marker");
  for(var i=radios.length-1;i>=0;i--) radios[i].style.backgroundColor="transparent";
  var imgid = "image_" + id.substring(7);
  if ( doc.getElementById(imgid) ) doc.getElementById(imgid).style.backgroundColor="#ffffff";
}
//-->
</script>
';
include 'qtg_adm_p_header.php';
include 'qtg_adm_menu.php';

echo '
<form method="post" action="',$pg_url,'" onsubmit="return ValidateForm(this,enterkeyPressed);">
<div class="subtitle">',$L['map']['Mapping_settings'],'</div>
<table width="100%" class="admin">
<tr>
<td class="admin_top" style="width:120px;"><span class="texthead"><label for="qtg_gkey">Google API key</label></span></td>
<td class="admin"><input id="qtg_gkey" name="qtg_gkey" size="75" maxlength="100" value="',$qtg_gkey,'"> *</td>
</tr>
';

//-----------
if ( !empty($qtg_gkey) ) {
//-----------

// Read png in directory

$intHandle = opendir('map');
$arrFiles = array();
while(false!==($strFile=readdir($intHandle)))
{
  if ( $strFile!='.' && $strFile!='..' ) {
  if ( substr($strFile,-4,4)=='.png' ) {
  if ( !strstr($strFile,'shadow') ) {
    $arrFiles[substr($strFile,0,-4)]=ucfirst(substr(str_replace('_',' ',$strFile),0,-4));
  }}}
}
closedir($intHandle);
asort($arrFiles);

echo '<tr>
<td class="admin_top">',$L['map']['API_ctrl'],'</td>
<td class="admin">
<input type="checkbox" id="streetview" name="streetview"'.(substr($qtg_gbuttons,1,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="streetview">',$L['map']['Ctrl_streetview'],'</label>
&nbsp;<input type="checkbox" id="map" name="map"'.(substr($qtg_gbuttons,2,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="map">',$L['map']['Ctrl_background'],'</label>
&nbsp;<input type="checkbox" id="scale" name="scale"'.(substr($qtg_gbuttons,3,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="scale">',$L['map']['Ctrl_scale'],'</label>
&nbsp;<input type="checkbox" id="overview" name="overview"'.(substr($qtg_gbuttons,4,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="overview">',$L['map']['Ctrl_overview'],'</label>
&nbsp;<input type="checkbox" id="mousewheel" name="mousewheel"'.(substr($qtg_gbuttons,5,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="mousewheel">',$L['map']['Ctrl_mousewheel'],'</label>
</td>
</tr>
<tr>
<td class="admin_top">',$L['map']['Symbol'],'</td>
<td class="admin">
<input type="radio" name="qtg_gsymbol" value="0" id="symbol_0"'.($qtg_gsymbol===false ? QCHE : '').' onchange="radioHighlight(this.id);"/><label for="symbol_0"><img id="image_0" class="marker'.($qtg_gsymbol==$strFile ? ' checked' : '').'" title="default" src="bin/css/gmap_marker.png"/></label>
';
foreach ($arrFiles as $strFile=>$strName)
{
echo '<input type="radio" name="qtg_gsymbol" value="'.$strFile.'" id="symbol_'.$strFile.'"'.($qtg_gsymbol==$strFile ? QCHE : '').' onchange="radioHighlight(this.id);"/><label for="symbol_'.$strFile.'"><img id="image_'.$strFile.'" class="marker'.($qtg_gsymbol==$strFile ? ' checked' : '').'" title="'.$strName.'" src="map/'.$strFile.'.png"/></label>'.PHP_EOL;
}
echo '</td>
</tr>
</table>
';
echo '<div class="subtitle">',$L['map']['Mapping_config'],'</div>
<table width="100%" class="admin">
<tr>
<tr>
<td class="admin_top" style="width:120px;"><label for="qtg_gcenter">',$L['map']['Center'],'</label></td>
<td class="admin" style="width:280px;"><input type="text" id="qtg_gcenter" name="qtg_gcenter" size="28" maxlength="100" value="',$qtg_gcenter,'"/><span class="small"> ',$L['map']['Latlng'],'</span></td>
<td class="admin_help">',$L['map']['H_Center'],'</td>
</tr>
';
echo '<tr>
<td class="admin_top"><label for="qtg_gzoom">',$L['map']['Zoom'],'</label></td>
<td class="admin">
<input type="text" id="qtg_gzoom" name="qtg_gzoom" size="2" maxlength="2" value="',$qtg_gzoom,'"/></td>
<td class="admin_help">',$L['map']['H_Zoom'],'</td>
</tr>
';
echo '<tr>
<td class="admin_top">',$L['map']['Background'],'</td>
<td class="admin"><select id="maptype" name="maptype" size="1">',QTasTag($L['map']['Back'],substr($qtg_gbuttons,0,1)),'</select></td>
<td class="admin_help">',$L['map']['H_Background'],'</td>
</tr>
';
echo '<tr>
<td class="admin_top"><label for="qtg_gfind">',$L['map']['Address_sample'],'</label></td>
<td class="admin">
<input type="text" id="qtg_gfind" name="qtg_gfind" size="20" maxlength="100" value="',$qtg_gfind,'"/></td>
<td class="admin_help">',$L['map']['H_Address_sample'],'</td>
</tr>
';

//-----------
}
//-----------

echo '</table>
<p style="text-align:center"><input type="submit" name="ok" value="',$L['Save'],'"/></p>
</form>
';

if ( !empty($qtg_gkey) )
{
  echo '<div class="gmap">',PHP_EOL;
  echo '<p class="small commands" style="margin:2px 0 4px 2px;text-align:right">',$L['map']['canmove'],' | <a class="small" href="javascript:void(0)" onclick="undoChanges(); return false;"/>',$L['map']['undo'],'</a></p>',PHP_EOL;
  echo '<div id="map_canvas"></div>',PHP_EOL;
  echo '<p class="small commands" style="margin:4px 0 2px 2px;text-align:right">',$L['map']['addrlatlng'];
  echo ' <input type="text" size="24" id="find" name="find" class="small" value="'.$qtg_gfind.'" title="'.$L['map']['H_addrlatlng'].'" onkeypress="enterkeyPressed=qtKeyEnter(event); if (enterkeyPressed) showLocation(this.value,null);"/>';
  echo '<img id="findit" src="qtg_map_find.png" onclick="showLocation(document.getElementById(\'find\').value,null);" style="margin:0 0 0 2px;padding:2px;vertical-align:middle;width:16px;height:16px;border:solid 1px #cccccc;border-radius:3px;cursor:pointer" title="'.L('Search').'"/>',PHP_EOL;
  echo '</div>',PHP_EOL;
}
else
{
  echo '<p class="disabled">',$L['map']['E_disabled'],'</p>';
}

if ( file_exists(GetLang().'qtg_map_adm.php.txt') )
{
	echo '<p class="admin_help">* ';
	include GetLang().'qtg_map_adm.php.txt';
	echo '</p>';
}

// --------
// HTML END
// --------

if ( !empty($qtg_gkey) )
{
  $gmap_markers = array();
  $gmap_events = array();
  $gmap_functions = array();

  $gmap_markers[] = QTgmapMarker($qtg_gcenter,true,$qtg_gsymbol,$L['map']['Define_center']);
  $gmap_events[] = '
	google.maps.event.addListener(marker, "position_changed", function() {
		if (document.getElementById("qtg_gcenter")) {document.getElementById("qtg_gcenter").value = gmapRound(marker.getPosition().lat(),10) + "," + gmapRound(marker.getPosition().lng(),10);}
	});
	google.maps.event.addListener(marker, "dragend", function() {
		map.panTo(marker.getPosition());
	});';
  $gmap_functions[] = '
  function undoChanges()
  {
  	if (infowindow) infowindow.close();
  	if (markers[0]) markers[0].setPosition(mapOptions.center);
  	if (mapOptions) map.panTo(mapOptions.center);
  	return null;
  }
  function showLocation(address,title)
  {
    if ( infowindow ) infowindow.close();
    geocoder.geocode( { "address": address}, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK)
      {
        map.setCenter(results[0].geometry.location);
        if ( markers[0] )
        {
          markers[0].setPosition(results[0].geometry.location);
        } else {
          markers[0] = new google.maps.Marker({map: map, position: results[0].geometry.location, draggable: true, animation: google.maps.Animation.DROP, title: title});
        }
        gmapYXfield("qtg_gcenter",markers[0]);
      } else {
        alert("Geocode was not successful for the following reason: " + status);
      }
    });
  }
  ';
  include 'qtg_map_load.php';
}

include 'qtg_adm_p_footer.php';