<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk Guestbook
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2009-2012 The PHP Group
* @version    3.0 build:20120924
*/

session_start();
require_once 'qtg_init.php';
if ( !isset($_SESSION['qtgAuth']) || $_SESSION['qtgAuth']!='yes' ) HtmlRedirect('qtg_adm_login.php'); // CHECK LOGIN

include 'bin/qt_class_table.php';
include GetLang().'qtg_adm.php';
if ( !empty($qtg_gkey) ) include 'qtg_map_lib.php';

$qtg_bbctags = array('B'=>true,'I'=>true,'U'=>true,'A'=>true,'S'=>true); // administrator can view all the bbc

$qtg_skin='bin/css';
$pg_name=$L['Messages'];
$pg_url='qtg_adm_msg.php';
$strOrder='issuedate';
$strDirec='desc';

if ( $qtg_page_size<50 ) $qtg_page_size=$qtg_page_size*2;

// --------
// SUBMITTED (as GET, single row)
// --------

if ( isset($_GET['id']) )
{
  if ( isset($_GET['v']) )
  {
  $oPost = new cPost();
  $oPost->id=cPost::UnHash($_GET['id']);
  $oPost->SetStatus($_GET['v']);
  // exit
  $_SESSION['pagedialog'] = (empty($error) ? 'O|'.$L['S_update'] : 'E|'.$error);
  }
}

// --------
// SUBMITTED (as POST, multiple rows)
// --------

if ( isset($_POST['action']) && ($_POST['action']=='hide' || $_POST['action']=='unhide') )
{
  $arr = array();
  if ( !isset($_POST['ids']) )
  {
    // ask confirmation
    if ( isset($_POST['t1_cb']) ) $arr = (is_array($_POST['t1_cb']) ? $_POST['t1_cb'] : explode(',',$_POST['t1_cb']));
    if ( count($arr)>0 )
    {
    	include 'qtg_adm_p_header.php';
    	include 'qtg_adm_menu.php';
    	$oHtml->Msgbox($L['Confirm'],array('style'=>'width:250px'));
    	echo '<form method="post" action="'.$pg_url.'">
    <p style="text-align:right">'.($_POST['action']=='hide' ? $L['Hide'] : $L['Unhide'] ).' ('.L('Message',count($arr)).')</p>
    <p style="text-align:right"><input type="hidden" name="action" value="'.$_POST['action'].'" />
    <input type="hidden" name="ids" value="'.implode(',',$arr).'" />
    <input type="submit" name="ok" value="'.$L['Ok'].' !" /></p>
    </form><p style="margin:10px 0 0 0"><a href="',Href($pg_url),'">&laquo; ',$pg_name,'</a></p>';
    	$oHtml->Msgbox(END);
    	include 'qtg_adm_p_footer.php';
    exit;
    }
    else
    {
    $warning = $L['E_nothing_selected'];
    }
  }
  else
  {
    $arr = explode(',',$_POST['ids']);
    foreach($arr as $id)
    {
	$oPost = new cPost();
	$oPost->id=cPost::Unhash($id);
	$oPost->SetStatus($_POST['action']=='hide' ? 'N' : 'Y');
    }
    // End message
    $_SESSION['pagedialog'] = 'O|'.$L['S_update'].'|'.count($arr);
  }
}

if ( isset($_POST['action']) && $_POST['action']=='delete' )
{
  $arr = array();
  if ( !isset($_POST['ids']) )
  {
  	// ask confirmation
  	if ( isset($_POST['t1_cb']) ) $arr = (is_array($_POST['t1_cb']) ? $_POST['t1_cb'] : explode(',',$_POST['t1_cb']));
	if ( count($arr)>0 )
	{
	  include 'qtg_adm_p_header.php';
	  include 'qtg_adm_menu.php';
	  $oHtml->Msgbox($L['Confirm'],array('style'=>'width:250px'));
	  echo '<form method="post" action="'.$pg_url.'">
    <p style="text-align:right">'.$L['Delete'].' ('.L('Message',count($arr)).')</p>
    <p style="text-align:right"><input type="hidden" name="action" value="'.$_POST['action'].'" />
    <input type="hidden" name="ids" value="'.implode(',',$arr).'" />
    <input type="submit" name="ok" value="'.$L['Delete'].' !" /></p>
    </form><p style="margin:10px 0 0 0"><a href="',Href($pg_url),'">&laquo; ',$pg_name,'</a></p>';
	  $oHtml->Msgbox(END);
	  include 'qtg_adm_p_footer.php';
	  exit;
	}
	else
	{
	  $error = $L['E_nothing_selected'];
	}
  }
  else
  {
	$arr = explode(',',$_POST['ids']);
	foreach($arr as $id)
	{
	  $oPost = new cPost();
	  $oPost->id=cPost::Unhash($id);
	  $oPost->Delete();
	}
	// End message
	$_SESSION['pagedialog'] = 'O|'.$L['S_delete'].'|'.count($arr);
  }
}
// --------
// HTML START
// --------

$oHtml->scripts[] = ' <script type="text/javascript" src="bin/qtg_table.js"></script>
<script type="text/javascript">
<!--
function datasetcontrol_click(checkboxname,action)
{
  var checkboxes = document.getElementsByName(checkboxname);
  var n = 0;
  for (var i=0; i<checkboxes.length; i++) if ( checkboxes[i].checked ) n++;
  if ( n>0 )
  {
  document.getElementById("form_messages_action").value=action;
  document.getElementById("form_messages").submit();
  return;
  }
  else
  {
  alert(qtHtmldecode("'.L('No_selected_row').'"));
  return false;
  }
}

$(document).ready(function() {

  $("#t1 td:not(.tdcheckbox,.tdaction)").click(function() { qtCheckboxToggle(this.parentNode.id.substring(3)); });

  // CHECKBOX ALL ROWS

  $("input[id=\'t1_cb\']").click(function() { qtCheckboxAll("t1_cb","t1_cb[]",true); });

  // SHIFT-CLICK CHECKBOX

  var lastChecked1 = null;
  var lastChecked2 = null;
  $("input[name=\'t1_cb[]\']").click(function(event) {
    if(!lastChecked1)
    {
      lastChecked1 = this;
      qtHighlight("tr_"+this.id,this.checked);
      return;
    }
    if(event.shiftKey)
    {
      var start = $("input[name=\'t1_cb[]\']").index(this);
      var end = $("input[name=\'t1_cb[]\']").index(lastChecked1);
      for(var i=Math.min(start,end);i<=Math.max(start,end);i++)
      {
      $("input[name=\'t1_cb[]\']")[i].checked = lastChecked1.checked;
      qtHighlight("tr_"+$("input[name=\'t1_cb[]\']")[i].id,lastChecked1.checked);
      }
    }
    lastChecked1 = this;
    qtHighlight("tr_"+this.id,this.checked);
  });
});

function showpreview(id)
{
  var doc=document;
  var item="name";
  var textmsg = doc.getElementById("textmsg_"+id); if ( !textmsg ) return;
  var dialog = doc.getElementById("notedialog"); if ( !dialog ) return;
  var status = doc.getElementById("status_"+id).outerHTML; if ( !status ) status="";
  dialog.innerHTML = "<p class=\"bold\">" + status + " " + textmsg.title + "</p>" + textmsg.innerHTML;
  $("#notedialog").dialog({title:item});
  $("#notedialog").dialog("open");
}
function doselect(checkboxname,action)
{
  var checkboxes = document.getElementsByName(checkboxname);
  var i = checkboxes.length - 1;
  do
  {
  switch(action)
  {
  case "none":    checkboxes[i].checked=false; break;
  case "hidden":  checkboxes[i].checked=(checkboxes[i].id.substring(checkboxes[i].id.length-2)=="_N"); break;
  case "visible": checkboxes[i].checked=(checkboxes[i].id.substring(checkboxes[i].id.length-2)=="_Y"); break;
  default:        checkboxes[i].checked=true; break;
  }
  qtHighlight("tr_"+checkboxes[i].id,checkboxes[i].checked);
  }
  while (i--);
  qtCheckboxOne(checkboxname,"t1_cb");
}
//-->
</script>
';

include 'qtg_adm_p_header.php';
include 'qtg_adm_menu.php';

if ( $oDB->type=='file' )
{
echo '<p class="small disabled" style="margin:0 0 10px 0">Repository&nbsp; ',$oDB->root,'</p>';
}

if ( isset($_GET['page']) ) { $limit=($_GET['page']-1)*$qtg_page_size; $page=intval($_GET['page']); } else { $limit=0; $page=1; }

// count topics

$intCount = 0;
if ( is_a($oDB,'cDT') )
{
  $intCount = $oDB->FilesCount();
}
else
{
  $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0' );
  if ($row = $oDB->Getrow()) $intCount = (int)$row['countid'];
}

$table = new cTable('t1','messages',$intCount);

// ---------------
if ( $intCount>0 ) {
// ---------------

// pager

$strPager = MakePager(Href('qtg_adm_msg.php'),$intCount,$qtg_page_size,$page);
if ( $strPager!='' ) $strPager = $L['Page'].$strPager;

// data command

$strDataCommand = '<a class="datasetcontrol" onclick="datasetcontrol_click(\'t1_cb[]\',\'unhide\'); return false;" href="javascript:void(0);">'.L('Unhide').'</a> &middot;
<a class="datasetcontrol" onclick="datasetcontrol_click(\'t1_cb[]\',\'hide\'); return false;" href="javascript:void(0);">'.L('Hide').'</a> &middot;
<a class="datasetcontrol" onclick="datasetcontrol_click(\'t1_cb[]\',\'delete\'); return false;" href="javascript:void(0);">'.L('Delete').'</a> |
'.L('select').':
<a class="datasetcontrol" onclick="doselect(\'t1_cb[]\',\'hidden\'); return false;" href="javascript:void(0);">'.L('hidden').'</a>
<a class="datasetcontrol" onclick="doselect(\'t1_cb[]\',\'visible\'); return false;" href="javascript:void(0);">'.L('visible').'</a>
<a class="datasetcontrol" onclick="doselect(\'t1_cb[]\',\'none\'); return false;" href="javascript:void(0);">'.L('none').'</a>'.PHP_EOL;

// query

if ( is_a($oDB,'cDT') )
{
  // $oDB->GetFiles();
  rsort($oDB->arrFiles);
  if ( count($oDB->arrFiles)>$qtg_page_size ) $oDB->arrFiles = array_slice($oDB->arrFiles, $limit, $qtg_page_size-1);
  $oDB->curFiles=0;
}
else
{
  $oDB->Query( LimitSQL($oDB->type,'* FROM '.TABMESSAGE.' WHERE id>=0','issuedate DESC',$limit,$qtg_page_size,$intCount) );
}

echo '
<form id="form_messages" method="post" action="',$pg_url,'"><input type="hidden" id="form_messages_action" name="action" value=""/>
<table class="pager_zt"><tr>',($intCount<3 ? '' : '<td class="pager_zt"><img src="bin/css/selection_up.gif" style="width:10px;height:10px;vertical-align:bottom;margin:0 10px 0 10px" alt="|" />'.$strDataCommand.'</td>'),'<td class="pager_zt right">',$strPager,'</td></tr></table>
';

  // === TABLE DEFINITION ===
  $table->activecol = $strOrder;
  $table->activelink = '<a  href="'.$pg_url.'?page=1&amp;order='.$strOrder.'&amp;dir='.($strDirec=='asc' ? 'desc' : 'asc').'">%s</a> <img class="i_sort" src="bin/css/sort_'.$strDirec.'.gif" alt="+"/>';
  $table->th['checkbox'] = new cTableHead(($table->rowcount<3 ? '&nbsp;' : '<input type="checkbox" name="t1_cb_all" id="t1_cb" />'));
  $table->th['issuedate']= new cTableHead(L('Date'),'','thissuedate');
  $table->th['source']  = new cTableHead(L('Source'),'','thsource');
  $table->th['message']  = new cTableHead($L['Message'],'','thmessage');
  if ( !empty($qtg_gkey) ) $table->th['coord'] = new cTableHead('&nbsp;','','thcoord');
  $table->th['action']   = new cTableHead('Action','','thaction');
  // create column data (from headers identifiers) and add class to all
  foreach($table->th as $key=>$th)
  {
    $table->td[$key] = new cTableData();
  }
  $table->td['checkbox']->Add('class','tdcheckbox');
  $table->td['issuedate']->Add('class','tdissuedate');
  $table->td['source']->Add('class','tdsource');
  $table->td['message']->Add('class','tdmessage');
  if ( !empty($qtg_gkey) ) $table->td['coord']->Add('class','tdcoord');
  $table->td['action']->Add('class','tdaction');

  // === TABLE START DISPLAY ===

  echo PHP_EOL;
  echo $table->Start().PHP_EOL;
  echo '<thead>'.PHP_EOL;
  echo $table->GetTHrow(2).PHP_EOL;
  echo '</thead>'.PHP_EOL;
  echo '<tbody>'.PHP_EOL;

  $strAlt='r1';
  while($row=$oDB->Getrow())
  {
    $oPost = new cPost($row);
    if ( !$row ) break;

    $id = cPost::Hash($oPost->id); // use hashed

    // prepare row
    $table->row = new cTableRow( 'tr_t1_cb'.$id.'_'.$oPost->visible, 'message '.$strAlt.' rowlight' );
    $table->td['checkbox']->content = ($table->rowcount<3 ? '&nbsp;' : '<input type="checkbox" name="t1_cb[]" id="t1_cb'.$id.'_'.$oPost->visible.'" value="'.$id.'" />');
    $table->td['issuedate']->content= (empty($oPost->issuedate) ? '&nbsp;' : QTdatestr($oPost->issuedate,'Y-m-d',''));
    $table->td['source']->content = '<span class="name">'.$oPost->name.'</span>'.( $oPost->userage>0 ? ' ('.$oPost->userage.')' :'' ).'<br/>';
      if ( !empty($oPost->postfrom) ) $table->td['source']->content .= $oPost->postfrom.' ';
      if ( !empty($oPost->ip) ) $table->td['source']->content .= 'ip '.$oPost->ip;
      if ( !empty($oPost->useremail) ) $table->td['source']->content .= ' <a href="mailto:'.$oPost->useremail.'" title="'.$oPost->useremail.'"><img src="bin/css/ico_mail.gif" class="ico"/></a>';
    $table->td['message']->content  = IQTbbc($oPost,' ',180,null,null,$qtg_skin,$page);
    if ( !empty($qtg_gkey) )
    {
    $table->td['coord']->content = ($oPost->hasCoord() ? ' <img class="ico" src="bin/css/ico_map.gif" alt="G" title="lat,long: '.QTdd2dms((float)$oPost->y).','.QTdd2dms((float)$oPost->x).'"/>' : ' <img class="ico" src="bin/css/ico_map_no.gif" alt="G" title="no coordinates"/>');
    }
    $table->td['action']->content   = '<a href="qtg_msg_edit.php?adm&amp;id='.$id.'&amp;page='.$page.'">'.$L['Edit'].'</a> &middot; ';
    $table->td['action']->content  .= '<a href="qtg_msg_del.php?adm&amp;id='.$id.'&amp;page='.$page.'">'.$L['Delete'].'</a> &middot; ';
    if ( $oPost->visible=='Y' )
    {
    $table->td['action']->content  .= '<a href="qtg_adm_msg.php?id='.$id.'&amp;v=N&amp;page='.$page.'">'.$L['Hide'].'</a>';
    }
    else
    {
    $table->row->Add('class','hidden');
    $table->td['action']->content  .= '<a href="qtg_adm_msg.php?id='.$id.'&amp;v=Y&amp;page='.$page.'">'.$L['Unhide'].'</a>';
    }
    echo $table->GetTDrow().PHP_EOL;
    if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }
  }

  // === TABLE END DISPLAY ===

  echo '</tbody>',PHP_EOL;
  echo '</table>',PHP_EOL;

  echo '<table class="pager_zb"><tr>',($intCount<3 ? '' : '<td class="pager_zb"><img src="bin/css/selection_down.gif" style="width:10px;height:10px;vertical-align:top;margin:0 10px 0 10px" alt="|" />'.$strDataCommand.'</td>'),'<td class="pager_zb right">',$strPager,'</td></tr></table>',PHP_EOL;
  echo '</form>',PHP_EOL;

}
else
{
  if ( !empty($strPager) ) echo '<table class="hidden"><tr><td class="pager_zt right">',$strPager,'</td></tr></table>',PHP_EOL;
  $table->th[] = new cTableHead('&nbsp;');
  echo $table->GetEmptyTable('<p style="margin-left:10px;margin-right:10px">'.L('None').'...</p>',true,'','r1');
}

// --------
// HTML END
// --------

include 'qtg_adm_p_footer.php';